﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;

namespace EntityFramework
{
    public class LoLDbContext : DbContext
    {
        public DbSet<ChampionEntity> Champions { get; set; }

        public LoLDbContext()
        { }

        public LoLDbContext(DbContextOptions<LoLDbContext> options)
            : base(options)
        { }


        protected override void OnConfiguring(DbContextOptionsBuilder options)
        {
            if (!options.IsConfigured)
            {
                options.UseSqlite("Data Source=champion.db");
            }
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<ChampionEntity>().HasKey(entity => entity.Name);
            modelBuilder.Entity<ChampionEntity>().ToTable("Champion");

            //modelBuilder.Entity<ChampionEntity>().Property(entity => entity.Id)
            //    .ValueGeneratedOnAdd();
            
            modelBuilder.Entity<ChampionEntity>().Property(entity => entity.Name)
                .IsRequired()
                .HasMaxLength(50);

            modelBuilder.Entity<ChampionEntity>().Property(entity => entity.Bio)
                .HasMaxLength(500)
                .HasColumnName("Bio")
                .HasColumnType("string");

            modelBuilder.Entity<ChampionEntity>().Property(entity => entity.Icon)
                .IsRequired();
            

        }
    }
}
